Bug 4949 - Hindi (Devanagari) Keyboard Map Updates
Summary: Hindi (Devanagari) Keyboard Map Updates
Status: RESOLVED FIXED
Alias: None
Product: xkeyboard-config
Classification: Unclassified
Component: General (show other bugs)
Version: unspecified
Hardware: x86 (IA32) Linux (All)
: high normal
Assignee: xkb
QA Contact:
URL: http://bugzilla.xfree.org/show_bug.cg...
Whiteboard:
Keywords: i18n, l10n
Depends on:
Blocks:
 
Reported: 2005-11-02 23:20 UTC by David Holl
Modified: 2006-10-10 16:05 UTC (History)
0 users

See Also:
i915 platform:
i915 features:


Attachments
pc/dev XKB Devanagari map (6.48 KB, text/plain)
2005-11-02 23:22 UTC, David Holl
Details
cvs diff of Indian - Devanagari/INSCRIPT map update (5.98 KB, patch)
2006-03-04 18:14 UTC, David Holl
Details | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description David Holl 2005-11-02 23:20:48 UTC
Hello --- I'm not sure how much you communicate with the XFree86 project, but in
April of 2004, I submitted a new Devanagari keyboard map to replace the current
one in /etc/X11/xkb/symbols/pc, and the submission was accepted for XFree86
4.4.99.3 (12 April 2004).  However, I don't see the update in X.org, though I do
see other XFree related maps... :)

My bugzilla submission to the XFree project is here:
    http://bugzilla.xfree.org/show_bug.cgi?id=1317

And the keyboard map in question is:
    http://www.ad5ey.net/~david/projects/devanagari.xkb
(descriptive page: http://www.ad5ey.net/~david/projects/inscript )

I created the updated Devanagari layout to conform (as best I could make
it) with the Unicode+INSCRIPT standards, and added a few keys to (hopefully)
make it slightly more comfortable for people used to other systems' Hindi
layouts.  Also, it is Very similar to the existing XFree/X.org layout primarilly
except for the added symbols in shift levels three and four.

I offer the layout to the X.org project -- feel free to crop the user-friendly
comments at the top or whatever.  (though it might be nice to have my name
somewhere in there so I can catch bug-mail)  :)  And please tell me if there's
anything I could do to make improvements.
Comment 1 David Holl 2005-11-02 23:22:21 UTC
Created attachment 3687 [details]
pc/dev XKB Devanagari map
Comment 2 Simos Xenitellis 2006-03-04 03:26:30 UTC
Yep, you are right; you have to send the update here as well due to licensing
issues. Xorg is used in most Linux distributions nowdays.

Changing the product to xkeyboard-config
Comment 3 Simos Xenitellis 2006-03-04 03:33:35 UTC
David, I notice there is another Devanagari keyboard map shown at
http://anakin.ncst.ernet.in/~aparna/consolidated/x1740.html
Is that the one you worked on to produce this keymap? 
Do you think it is possible to contact the Hindi Linux Group to get some sort of
consensus for this?

The keyboard configuration files in Xorg are handled by xkeyboard-config, 
http://www.freedesktop.org/wiki/Software_2fXKeyboardConfig

The files on CVS are located at
http://webcvs.freedesktop.org/xlibs/xkbdesc/

You can discuss about these at the list
http://listserv.bat.ru/xkb/List.html
Comment 4 David Holl 2006-03-04 17:40:18 UTC
(In reply to comment #3)
> David, I notice there is another Devanagari keyboard map shown at
> http://anakin.ncst.ernet.in/~aparna/consolidated/x1740.html
> Is that the one you worked on to produce this keymap? 
> Do you think it is possible to contact the Hindi Linux Group to get some sort 
> of consensus for this?

Yes, the keymap listed at the site you list (ernet.in) is exactly the one that I
replaced in the XFree86 project.  The map I provided contains all of the old
map's functionality plus adds some of the characters defined in the INSCRIPT
standard as well as common keys listed from the MS and Java/Sun key maps.  (ie,
the map currently in X.org is missing a few symbols)

> The keyboard configuration files in Xorg are handled by xkeyboard-config, 
> http://www.freedesktop.org/wiki/Software_2fXKeyboardConfig

Hmm -- should I be submitting the keymap to this project as well?

???  aieee...  I just wanted to add in the missing symbols.  I just checked out
their CVS branch and it appears their "symbols/in" file used the same incomplete
map from XFree project (even noted in the comments!) which was replaced with
this newer, more complete map.  (I'm wondering if I just missed this copy/paste
band wagon...)
Comment 5 David Holl 2006-03-04 18:13:07 UTC
For standards, try the Indian government:
  http://tdil.mit.gov.in/uni.htm
  http://tdil.mit.gov.in/keyoverlay.htm

And for reference, check out what that other OS implements:
  http://www.microsoft.com/globaldev/reference/keyboards.mspx
  (select "Devanagari - INSCRIPT" in their drop down list)

(My map is a lot closer inline with the Indian Gov standard AND the MS layouts
than the old layout currently in X.org / xkeyboard-config...)

So you might ask, what is my kayboard map missing?  There is a set of symbols
that normally occupy shifted positions above the numbers, which when pressed,
need to generate 3-4 key strokes each to conjur up the appropriate combining
forms.  Last time I checked (2 years ago), XKB was not capable of easilly
generating the extra strokes upon a single keypress.  So from that limitation,
neither my map, nor the (even more incomplete) map in X.org have those characters.

For details, check out the Indian Gov, and MS pages I listed above.
Comment 6 David Holl 2006-03-04 18:14:59 UTC
Created attachment 4816 [details] [review]
cvs diff of Indian - Devanagari/INSCRIPT map update
Comment 7 Sergey V. Udaltsov 2006-10-10 14:37:08 UTC
Thanks David, your patch is committed.
Comment 8 David Holl 2006-10-10 16:05:44 UTC
Hooray!  Thank you.

- David


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.